library AxPath;

uses
  Windows, SysUtils;

{$R *.res}

function AllowSetForegroundWindow(dwProcessId: DWORD): BOOl; stdcall; external user32 name 'AllowSetForegroundWindow';
function SHDeleteKey(hkey : HKEY; pszSubKey : PCHAR) : DWORD; stdcall; external 'shlwapi.dll' name 'SHDeleteKeyA';


function GetAxaptaDirectory(Name : String) : String;
var
  key : HKEY;
  binDir : String;
  cur : PChar;
  sz : Integer;
  t : Integer;
  i : Integer;
begin
  if (RegOpenKey(HKEY_CURRENT_USER, 'Software\Navision\Axapta\3.0', key) <> ERROR_SUCCESS) then Exit;

  cur := nil;
  sz := 0;
  if Name = '' then
  begin
    i := RegQueryValueEx(key, 'Current', nil, @t, nil, @sz);
    if i = ERROR_SUCCESS then
    begin
      GetMem(cur, sz);
      RegQueryValueEx(key, 'Current', nil, @t, pbyte(cur), @sz);
      RegCloseKey(key);
      Name := cur;

    end;
  end;
  if cur <> nil then FreeMem(cur);

  binDir := '';
  if (RegOpenKey(HKEY_CURRENT_USER, PChar('Software\Navision\Axapta\3.0\' + Name), key) = ERROR_SUCCESS) then
  begin
    i := RegQueryValueEx(key, 'bindir', nil, @t, nil, @sz);
    if i = ERROR_SUCCESS then
    begin
      GetMem(cur, sz);
      cur[0] := #0;
      RegQueryValueEx(key, 'bindir', nil, @t, pbyte(cur), @sz);

      binDir := cur;
      if (binDir <> '') and (binDir[length(binDir)] <> '\') then binDir := binDir + '\';
      if cur <> nil then FreeMem(cur);
    end;
    RegCloseKey(key);
  end;
  result := binDir;
end;

const
  HeaderSize = 10;
  HandlersOffset = 10;
  HandlerIdOffset = 0;
  HandlerActivityOffset = 1;
  HandlerConfigOffset = 2;
  MaxHandlerCount = 5;
  SizeOfHandler = $ff;

  MessagesOffset = HeaderSize + MaxHandlerCount * SizeOfHandler;
  MessageNextOffset = 0;
  MessageIdOffset = 2;
  MessageTextOffset = 3;

procedure AxPathHandler (hwnd : HWND; hinst : Integer; lpszCmdLine : PChar; nCmdShow : Integer); stdcall;
var
  f : THandle;
  bin : String;
  si : TStartupInfo;
  pi : TProcessInformation;
  Buf : Pointer;
  i   : Integer;
  cnt : Integer;
//  s : String;
  idx : Integer;
  Mutex : THandle;
  c : PChar;
  Lang : LANGID;
  function StrCmp(S : PChar) : Boolean;
  const
    h : array[0..6] of Char = ('A', 'x', 'P', 'a', 't', 'h', #0);
  var
    i : Integer;
  begin
    result := True;
    i := 0;
    while (i < 7) do
    begin
      if (s[i] <> h[i]) then
      begin
        result := False;
        break;
      end;
      Inc(i);
    end
  end;
begin
  Lang := GetSystemDefaultLangID;
//  MessageBox(hwnd, 'Ok!', 'Warning', MB_ICONEXCLAMATION);
  f := 0;
  while f = 0 do
  begin
    f := CreateFileMapping(INVALID_HANDLE_VALUE, nil, PAGE_READWRITE, 0, $ffff, 'Local\AxPathFileMappings');
    try
      if (F <> 0) then
      begin
        if GetLastError = ERROR_ALREADY_EXISTS then
        begin
        end
        else
        begin
          bin := GetAxaptaDirectory('');
          if bin <> '' then
          begin
            ZeroMemory(@si, SizeOf(TStartupInfo));
            si.cb := SizeOf(TStartupInfo);
            CreateProcess(nil, PChar(bin + 'ax32.exe'), nil, nil, false, 0, nil, PChar(bin), si, pi);
            if (pi.hProcess <> 0) then
            begin
              WaitForInputIdle(pi.hProcess, INFINITE);
              Closehandle(pi.hProcess);
              Closehandle(pi.hThread);
//              MessageBox(hwnd, 'Ok!', 'Warning', MB_ICONEXCLAMATION);
            end;
          end
          else
            if (Lang = $0419) or (Lang = $0422) or (Lang = $0423) then
              MessageBox(hwnd, 'Microsoft Business Solutions-Axapta 3.0  !', 'Error', MB_ICONEXCLAMATION)
            else
              MessageBox(hwnd, 'Microsoft Business Solutions-Axapta 3.0 is not installed!', 'Error', MB_ICONEXCLAMATION);

          f := 1;
        end;
        Mutex := CreateMutex(nil, false, 'Local\AxPathMutex');
        if Mutex <> INVALID_HANDLE_VALUE then
        begin
          try
            if WaitForSingleObject(Mutex, INFINITE) = WAIT_OBJECT_0 then
            begin
              buf := MapViewOfFile(f, FILE_MAP_ALL_ACCESS, 0, 0, $ffff);
              if buf <> nil then
                try
                  if StrCmp(PChar(buf)) then
                  begin
                    idx := 0;
                    for i := 0 to MaxHandlerCount - 1 do
                      if PByte(integer(buf) + HandlersOffset + SizeOfHandler * i + HandlerActivityOffset)^ = 1 then
                      begin
                        idx := i+1;
                        break;
                      end;
                    if idx > 0 then
                    begin
                      c := lpszCmdLine;
                      while (c[0] <> #0) do
                      begin
                        if (c[0] = ':') and (c[1] = '/') and (c[2] = '/') then
                        begin
                          Inc(c, 3);
                          break;
                        end;
                        inc(c);
                      end;
                      if c <> '' then
                      begin
                        cnt := 0;
                        while c[cnt] <> #0 do Inc(cnt);
                        if (cnt > 0) and (c[cnt-1] = '"') then
                          Dec(cnt);
                        i := MessagesOffset;
                        while (i < $ffff) and (PWord(integer(buf) + i)^ <> 0) do
                          i := i + PWord(integer(buf) + i)^;
                        if cnt + i + MessageTextOffset + 1 < $ffff-1 then
                        begin
                          PWord(integer(buf) + i + MessageNextOffset)^ := cnt + MessageTextOffset + 1;
                          PByte(integer(buf) + i + MessageIdOffset)^ := idx;
                          Move(c^, Pointer(integer(buf) + i + MessageTextOffset)^, cnt);
                          PByte(integer(buf) + i + MessageTextOffset + cnt)^ := 0;
                          PWord(integer(buf) + i + MessageTextOffset + cnt + 1)^ := 0;
                          AllowSetForegroundWindow(DWORD(-1));
                        end;
                      end;
                    end;  
                  end;
                finally
                  UnmapViewOfFile(buf);
                end;
            end  
          finally
            ReleaseMutex(Mutex);
          end;  
        end;  
      end;
    finally
      if f <> 0 then
        CloseHandle(f);
    end;
  end;
end;

procedure RegHandler;
var
  key : HKEY;
  binDir : String;
  cur : PChar;
  sz : Integer;
  t : Integer;
  i : Integer;
  s : String;
  Lang : LANGID;
begin
  Lang := GetSystemDefaultLangID;

  if (RegOpenKey(HKEY_CURRENT_USER, 'Software\Navision\Axapta\3.0', key) <> ERROR_SUCCESS) then Exit;

  cur := nil;
  sz := 0;
  i := RegQueryValueEx(key, 'Current', nil, @t, nil, @sz);
  if i = ERROR_SUCCESS then
  begin
    GetMem(cur, sz);
    RegQueryValueEx(key, 'Current', nil, @t, pbyte(cur), @sz);
    RegCloseKey(key);
  end;

  binDir := '';
  if (RegOpenKey(HKEY_CURRENT_USER, PChar('Software\Navision\Axapta\3.0\' + cur), key) = ERROR_SUCCESS) then
  begin
    FreeMem(cur); cur := nil;
    i := RegQueryValueEx(key, 'bindir', nil, @t, nil, @sz);
    if i = ERROR_SUCCESS then
    begin
      GetMem(cur, sz);
      cur[0] := #0;
      RegQueryValueEx(key, 'bindir', nil, @t, pbyte(cur), @sz);

      binDir := cur;
      if (binDir <> '') and (binDir[length(binDir)] <> '\') then binDir := binDir + '\';
    end;
    RegCloseKey(key);
  end;
  if cur <> nil then FreeMem(cur);

  try
    if (RegCreateKey( HKEY_CLASSES_ROOT, 'AxPath', key) = ERROR_SUCCESS) then
    begin
      RegSetValue(key, nil, REG_SZ, 'URL:Protocol AxPath', length('URL:Protocol AxPath'));
      RegSetValueEx(key, 'URL Protocol', 0, REG_SZ, nil, 0);
      RegCloseKey(key);

//      URL Protocol
      s := GetCurrentDir;
      if (s[length(s)] <> '\') then s := s + '\'; 
      if RegCreateKey( HKEY_CLASSES_ROOT, 'AxPath\DefaultIcon', key) = ERROR_SUCCESS then
      begin
        if binDir <> '' then
          RegSetValue(key, nil, REG_SZ, PChar(binDir + 'ax32.exe,0'), Length(binDir + 'ax32.exe,0'));
        RegCloseKey(key);
      end;
      if RegCreateKey( HKEY_CLASSES_ROOT, 'AxPath\Shell', key) = ERROR_SUCCESS then
      begin
        RegCloseKey(key);
        if RegCreateKey( HKEY_CLASSES_ROOT, 'AxPath\Shell\Open', key) = ERROR_SUCCESS then
        begin
          RegCloseKey(key);
          if RegCreateKey( HKEY_CLASSES_ROOT, 'AxPath\Shell\Open\Command', key) = ERROR_SUCCESS then
          begin
            s := 'rundll32 "' + s + 'AxPath.dll" AxPathHandler "%1"';
            RegSetValue(key, nil, REG_SZ, PChar(s), Length(s));
            RegCloseKey(key);
          end;
        end;
      end;
      if (Lang = $0419) or (Lang = $0422) or (Lang = $0423) then
         MessageBox(0, ' AxPath ', 'Information', MB_ICONINFORMATION)
      else
         MessageBox(0, 'AxPath handler registered', 'Information', MB_ICONINFORMATION)
    end
    else
    begin
      if (Lang = $0419) or (Lang = $0422) or (Lang = $0423) then
        MessageBox(0, '    AxPath', 'Error', MB_ICONEXCLAMATION)
      else
        MessageBox(0, 'Failed to register AxPath handler', 'Error', MB_ICONEXCLAMATION);
    end;
  except
    on e : Exception do
     MessageBox(0, Pchar(e.Message), 'Error', MB_ICONEXCLAMATION);
  end;
end;

procedure UnregHandler;
var
  key : HKEY;
  Lang : LANGID;
begin
  Lang := GetSystemDefaultLangID;

  if (RegOpenKey(HKEY_CLASSES_ROOT, 'AxPath', key) <> ERROR_SUCCESS) then Exit;
  RegCloseKey(key);
  SHDeleteKey(HKEY_CLASSES_ROOT, 'AxPath');

  if (Lang = $0419) or (Lang = $0422) or (Lang = $0423) then
    MessageBox(0, ' AxPath ', 'Information', MB_ICONINFORMATION)
  else
    MessageBox(0, 'AxPath handler removed', 'Information', MB_ICONINFORMATION);
end;

procedure AxPathReg (hwnd : HWND; hinst : Integer; lpszCmdLine : PChar; nCmdShow : Integer); stdcall;
begin
  RegHandler;
end;

procedure AxPathUnreg (hwnd : HWND; hinst : Integer; lpszCmdLine : PChar; nCmdShow : Integer); stdcall;
begin
  UnregHandler;
end;

function DllRegisterServer: HResult; stdcall;
begin
  RegHandler;
  result := S_OK;
end;

function DllUnregisterServer: HResult; stdcall;
begin
  UnregHandler;
  result := S_OK;
end;

exports
  AxPathHandler,
  AxPathReg,
  AxPathUnreg,
  DllRegisterServer,
  DllUnregisterServer;

begin
end.
